<?php
/**
* @version $Id: mod_latestnews_date.php v1.1
* @Coded by pe7er / db8.nl, 18 April 2008
* @This module shows the latest news with date formatted according to
* @Country Locale (set in Site > Global Configuration > Locale > Country Locale:)
* @and module parameter "Date/time format" which uses the date/time format
* @from PHP strftime, see: http://php.net/manual/en/function.strftime.php
* @Examples:
* @Country Locale: nl_NL and "%A %d %B %Y, %H:%I" will result in "maandag 9 augustus 2004, 18:30"
* @Country Locale: en_EN and "%A %d %B %Y, %H:%I" will result in "Monday 9 August 2004, 18:30"
*/

defined( '_VALID_MOS' ) or die( 'Restricted access' ); // no direct access

global $mosConfig_offset, $mosConfig_live_site, $mainframe;

$type 		= intval( $params->get( 'type', 1 ) );
$count 		= intval( $params->get( 'count', 5 ) );
$words	= $params->get( 'words', '30' );
$chars	= $params->get( 'chars', 250 );
$style	= $params->get( 'style', 'simple' );
$hideimages	= $params->get( 'hideimages', 0 );
$showreadmore	= $params->get( 'showreadmore', 'yes' );
$catid 		= trim( $params->get( 'catid' ) );
$secid 		= trim( $params->get( 'secid' ) );
$show_section_title 	= intval($params->get('show_section_title',1));
$show_category_title 	= intval($params->get('show_category_title',1));
$seperator 				= trim($params->get('seperator','&gt;&gt;'));
$show_front	= $params->get( 'show_front', 1 );
$showdate	= $params->get( 'showdate', 'yes' );
$titlelink	= $params->get( 'titlelink', 'yes' );
$showtitle	= $params->get( 'showtitle', 'yes' );
$showintro	= $params->get( 'showintro', 'yes' );
$dateformatday = $params->get( 'dateformatday', "%d" ) ; //Monday 9 August 2004, 8:30 
$dateformatmonth = $params->get( 'dateformatmonth', "%B" ) ; //Monday 9 August 2004, 8:30 
$dateformatyear = $params->get( 'dateformatyear', "%Y" ) ; //Monday 9 August 2004, 8:30 
$dateformathour = $params->get( 'dateformathour', " %H:%I %p" ) ; //Monday 9 August 2004, 8:30 
$css 					= $params->get( 'css', 'yes' );
$now 		= _CURRENT_SERVER_TIME;
$access 	= !$mainframe->getCfg( 'shownoauth' );
$nullDate 	= $database->getNullDate();



// select between Content Items, Static Content or both
switch ( $type ) {
	case 2: 
	//Static Content only
		$query = "SELECT a.id, a.title, a.created AS created,a.introtext,a.created_by_alias"
		. "\n FROM #__content AS a"
		. "\n WHERE ( a.state = 1 AND a.sectionid = 0 )"
		. "\n AND ( a.publish_up = '$nullDate' OR a.publish_up <= '$now' )"
		. "\n AND ( a.publish_down = '$nullDate' OR a.publish_down >= '$now' )"
		. ( $access ? "\n AND a.access <= $my->gid" : '' )
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$rows = $database->loadObjectList();
		break;

	case 3: 
	//Both
		$query = "SELECT a.id, a.title, a.sectionid, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state, s.published AS sec_state, a.created AS created,a.introtext,a.created_by_alias"
		. "\n FROM #__content AS a"
		. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\n LEFT JOIN #__categories AS cc ON cc.id = a.catid"
		. "\n LEFT JOIN #__sections AS s ON s.id = a.sectionid"
		. "\n WHERE a.state = 1"
		. "\n AND ( a.publish_up = '$nullDate' OR a.publish_up <= '$now' )"
		. "\n AND ( a.publish_down = '$nullDate' OR a.publish_down >= '$now' )"
		. ( $access ? "\n AND a.access <= $my->gid" : '' )
		. ( $catid ? "\n AND ( a.catid IN ( $catid ) )" : '' )
		. ( $secid ? "\n AND ( a.sectionid IN ( $secid ) )" : '' )
		. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$temp = $database->loadObjectList();
		
		$rows = array();
		if (count($temp)) {
			foreach ($temp as $row ) {
				if (($row->cat_state == 1 || $row->cat_state == '') &&  ($row->sec_state == 1 || $row->sec_state == '') &&  ($row->cat_access <= $my->gid || $row->cat_access == '' || !$access) &&  ($row->sec_access <= $my->gid || $row->sec_access == '' || !$access)) {
					$rows[] = $row;
				}
			}
		}
		unset($temp);
		break;

	case 1:  
	default:
	//Content Items only
		$query = "SELECT a.id, a.title, a.sectionid, a.catid, a.created AS created,a.introtext,a.created_by_alias"
		. "\n FROM #__content AS a"
		. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
		. "\n INNER JOIN #__categories AS cc ON cc.id = a.catid"
		. "\n INNER JOIN #__sections AS s ON s.id = a.sectionid"
		. "\n WHERE ( a.state = 1 AND a.sectionid > 0 )"
		. "\n AND ( a.publish_up = '$nullDate' OR a.publish_up <= '$now' )"
		. "\n AND ( a.publish_down = '$nullDate' OR a.publish_down >= '$now' )"
		. ( $access ? "\n AND a.access <= $my->gid AND cc.access <= $my->gid AND s.access <= $my->gid" : '' )
		. ( $catid ? "\n AND ( a.catid IN ( $catid ) )" : '' )
		. ( $secid ? "\n AND ( a.sectionid IN ( $secid ) )" : '' )
		. ( $show_front == '0' ? "\n AND f.content_id IS NULL" : '' )
		. "\n AND s.published = 1"
		. "\n AND cc.published = 1"
		. "\n ORDER BY a.created DESC"
		;
		$database->setQuery( $query, 0, $count );
		$rows = $database->loadObjectList();
		break;
}


// needed to reduce queries used by getItemid for Content Items
if ( ( $type == 1 ) || ( $type == 3 ) ) {
	$bs 	= $mainframe->getBlogSectionCount();
	$bc 	= $mainframe->getBlogCategoryCount();
	$gbs 	= $mainframe->getGlobalBlogSectionCount();
}

// Output


?>


<?php
foreach ( $rows as $row ) {
	// get Itemid
	switch ( $type ) {
		case 2:
			$query = "SELECT id"
			. "\n FROM #__menu"
			. "\n WHERE type = 'content_typed'"
			. "\n AND componentid = $row->id"
			;
			$database->setQuery( $query );
			$Itemid = $database->loadResult();
			break;

		case 3:
			if ( $row->sectionid ) {
				$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
			} else {
				$query = "SELECT id"
				. "\n FROM #__menu"
				. "\n WHERE type = 'content_typed'"
				. "\n AND componentid = $row->id"
				;
				$database->setQuery( $query );
				$Itemid = $database->loadResult();
			}
			break;

		case 1:
		default:
			$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
			break;
	}

	// Blank itemid checker for SEF
	if ($Itemid == NULL) {
		$Itemid = '';
	} else {
		$Itemid = '&amp;Itemid='. $Itemid;
	}
	// Character limitation - Borrowed from JoomlaWorks UCD
	if ($chars) {
		if(function_exists("mb_substr")) {
			$row->introtext = mb_substr($row->introtext, 0, $chars).'...';
		}
		else {
			$row->introtext = substr($row->introtext, 0, $chars).'...';
		}
	}
	
	// Word limitation  - Borrowed from JoomlaWorks UCD
	if (!function_exists('word_limiter')) {
		function word_limiter($str, $limit = 100, $end_char = '&#8230;') {
			if (trim($str) == '')
				return $str;
			preg_match('/\s*(?:\S*\s*){'. (int) $limit .'}/', $str, $matches);
			if (strlen($matches[0]) == strlen($str))
				$end_char = '';
			return rtrim($matches[0]).$end_char;
		}
	}
	if ($words) {
		$row->introtext = word_limiter($row->introtext,$words);
	}
	
	// Remove images - Borrowed from JoomlaWorks UCD
	if ($hideimages) {
		$row->introtext = preg_replace("/<img.+?>/", "", $row->introtext);	
	}
	
	// Section - Category display
	$cat = new mosCategory( $database );
		$cat->load( $row->catid );
		$sec = new mosSection( $database );
		$sec->load( $row->sectionid );
	$link = sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='. $row->id . $Itemid );
	?>
	<div class="microwrap_<?php echo $style ?>">
		
		<div class="microitem">
		<?php if ($titlelink == "yes") : ?>
			<a href="<?php echo $link; ?>"><?php echo $row->title; ?></a>
			
			<?php endif; ?>
		<?php if ($titlelink == "no") : ?>
			<span class="microtitle"><?php echo $row->title; ?></span>
		<?php endif; ?>
			
			<?php if ($showintro == "yes") : ?>
				<?php echo $row->introtext; ?>
			
				
				
			<?php endif; ?>
			<?php if ($showreadmore == "yes") : ?>
			<div class="details">
			<?php if ($showdate == "yes") : ?>
	<div class="microdate_wrap">
	<div class="microdate">
		 <span class='microday'><?php echo  strftime ($dateformatday, strtotime($row->created)) ?></span>
	 	 <span class='micromonth'><?php echo  strftime ($dateformatmonth, strtotime($row->created)) ?></span>
	 	 <span class='microyear'><?php echo  strftime ($dateformatyear, strtotime($row->created)) ?></span>
	 </div>
	
</div>
	<?php endif; ?>

	
		 <div class="micromore">
			<a href="<?php echo $link; ?>">Read More <img src="modules/mod_microblog/microblog/more.jpg" alt="Read More"/></a>
		</div>
		</div>
	<?php endif; ?>

	</div>
	</div>
	<?php
}
?>




